#! /usr/bin/env python
# -*- coding: UTF-8 -*-
#
# Contributed by Min Sik Kim
#

import codecs
import os
import stat
import sys

def usage():
    print 'Usage:', sys.argv[0], '<src_root> <dst_root>'
    sys.exit(0)


if len(sys.argv) != 3:
    usage()

src_root, dst_root = sys.argv[1], sys.argv[2]
if not os.path.exists(src_root):
    sys.stderr.write('Error: cannot find %s\n' % srcdir)
    sys.exit(1)


for root, dirs, files in os.walk(src_root):
    for name in files:
        src = os.path.join(root, name)
        dst = os.path.join(root.replace(src_root, dst_root),
                           name.replace('.txt', '.ldv'),
                           '__content__.wiki04')
        dstdir = os.path.dirname(dst)
        if not os.path.exists(dstdir):
            os.makedirs(dstdir)
        srcfile = codecs.getreader('UTF-8')(file(src, 'r'))
        dstfile = codecs.getwriter('UTF-8')(file(dst, 'w'))
        for line in srcfile.readlines():
            dstfile.write(line)
        dstfile.close()
        srcfile.close()
        s = os.stat(src)
        times = (s[stat.ST_ATIME], s[stat.ST_MTIME])
        os.utime(dst, times)
