#
#    Copyright (C) 2003-2004  James Tauber
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#



class ProviderManager:


    def __init__(self):
    
        self.providers = []
    
    
    def register_provider(self, provider):
        
        self.providers.append(provider)
        
        
    def get(self, resource_id, request, main_resource):
        """
        Attempts to retrieve the resource with the given resource_id.
        
        request is also passed in to provide authentication information and
        HTTP parameters. @@@ This could be improved.
        
        main_resource is None if the requested resource is what the client
        directly requested. Otherwise it is the actual resource object
        requested by the client (and the resource in resource_id is just
        a component being retrieved to contribute to the the main_resource).
        """
        
        for provider in self.providers:
            resource = provider.get(resource_id, request, main_resource)
            if resource:
                return resource
        return None